
//
// *************************************************************************
// *                                                                       *
// *    OMEGA C++ Windowing Class Library                                  *
// *    =================================                                  *
// *                                                                       *
// *    Copyright 1991,92 Tom Clancy                                       *
// *    Submitted to the public domain, April 1992                         *
// *                                                                       *
// *************************************************************************
// *                                                                       *
// *    Keyboard Methods                                                   *
// *                                                                       *
// *************************************************************************
//


#include "omkey.hpp"

int altkeys[26] = {330,348,346,332,318,333,334,335,323,336,337,338,
		   350,349,324,325,316,319,331,320,322,347,317,345,
		   321,344};

int key::istypeable(int k) {

  if(k>=32 && k<=126) return 1; else return 0;
}

char key::upcase(char c) {
  if(c>=97 && c<=122)
    c-=32;
  return c;
}

int key::makealt(char c) {
  int k=0;
  if(istypeable(c)) {
    c=upcase(c);
    c-=64;
    if(c>=1 && c<=26)
      k=altkeys[c-1];

  }
  return k;
}

int key::readkey() {

   char ch;

   while(!keypressed());
     ch=getch();
     if(!ch) {
       ch=getch();
       keycode=300+ch;
       extended=1;
     }
     else {
       extended=0;
       keycode=ch;
     }
   return keycode;
}
