//
// *************************************************************************
// *                                                                       *
// *    OMEGA C++ Windowing Class Library                                  *
// *    =================================                                  *
// *                                                                       *
// *    Copyright 1991,92 Tom Clancy                                       *
// *    Submitted to the public domain, April 1992                         *
// *                                                                       *
// *************************************************************************
// *                                                                       *
// *    Keyboard Class Object                                              *
// *                                                                       *
// *************************************************************************
//

#ifndef _OMKEY
#define _OMKEY
#endif

#include <conio.h>


enum key_events {


    BackSpace=8,
    Tab=9,
    ShiftTab=15,
    Enter=13,
    Escape=27,
    CtrlY=25,

    // begin extended keys at 300 to distinguish from regular keys.

    AltQ=316,AltW,AltE,AltR,AltT,AltY,AltU,AltI,AltO,AltP,
    AltA=330,AltS,AltD,AltF,AltG,AltH,AltJ,AltK,AltL,
    AltZ=344,AltX,AltC,AltV,AltB,AltN,AltM,

    F1=359,F2,F3,F4,F5,F6,F7,F8,F9,F10,Home=371,UpArrow=372,PgUp=373,
    LeftArrow=375,RightArrow=377,End=379,DownArrow=380,PgDn=381,Insert=382,
    Delete=383,

    ShF1=384,ShF2,ShF3,ShF4,ShF5,ShF6,ShF7,ShF8,ShF9,ShF10,

    CtrlF1=394,CtrlF2,CtrlF3,CtrlF4,CtrlF5,CtrlF6,CtrlF7,CtrlF8,CtrlF9,
    CtrlF10,

    AltF1=404,AltF2,AltF3,AltF4,AltF5,AltF6,AltF7,AltF8,AltF9,AltF10,

    CtrlPrtScr,CtrlLeftArrow,CtrlRightArrow,CtrlEnd,CtrlPgDn,CtrlHome,

    Alt1=420,Alt2,Alt3,Alt4,Alt5,Alt6,Alt7,Alt8,Alt9,Alt0,AltMinus,AltEquals,

    CtrlPgUp=432,F11,F12,ShF11,ShF12,CtrlF11,CtrlF12,AltF11,AltF12,
};



class key {

  int extended;
  int keycode;

public:

  key() {extended=0; keycode=0;}
  int   readkey();
  int   keypressed()  {return kbhit();}
  int   getkeycode()  {return keycode;}
  int   istypeable(int k);
  char  getkeychar()  {return (char)getkeycode();}
  int   extendedkey() {return extended;}
  char  upcase(char c);
  int   makealt(char c);

};
