//
// *************************************************************************
// *                                                                       *
// *    T_Menu Demonstration                                               *
// *                                                                       *
// *    OMEGA C++ Windowing Class Library                                  *
// *    =================================                                  *
// *                                                                       *
// *    Copyright 1991,92 Tom Clancy                                       *
// *    Submitted to the public domain, April 1992                         *
// *                                                                       *
// *************************************************************************
//

#include "omscreen.hpp"
#include "ommenu.hpp"

main () {
  initmouse();
  OMEGA_SETUP();
  oScreen S;
  S.cursoroff();
  S.setfgcolor(WHITE);
  S.setbkcolor(LIGHTGRAY);
  S.setfillchar(#176);
  S.clrscr();
  S.showmouse();

  oMenu p;

  p.setmenu(1,1,WHITE,BLUE,YELLOW,BLACK,CYAN,WHITE,SINGLEBAR);
  p.setboundaries(1,1,p.getscreenwid(),p.getscreenlen());
  p.setsolidheader(OFF);
  if(p.getsolidheader())
    p.settitle(" Main Menu ",tCenter,BLACK,LIGHTGRAY);
  else
    p.settitle(" Main Menu ",tCenter,WHITE,BLUE);
  p.setgap(2);
  p.addoption("~Add Records");
  p.addoption("Record ~Maintenance");
  p.addoption("Database ~Queries");
  p.addoption("~Report Generation");
  p.addoption("A~Pplication Generator");
  p.addoption("-");
  p.addoption("E~Xit Menu");
  p.setjustify(mCenterBoth);
  p.dragging(ON);
  p.resizing(ON);
  p.expanding(ON);
  p.closing(ON);
  p.setshadow(ON,shBottomright);
  while(p.getlastcmd()!=7 && p.getlastcmd()!=cmdClose) {
    p.gomenu();
  }
  S.hidemouse();
  S.restoreoldvmode();
  S.setfillchar(32);
  S.setbkcolor(BLACK);
  S.clrscr();
  S.cursoron();
  return 0;
}


