//
// *************************************************************************
// *                                                                       *
// *    T_Win Demonstration                                                *
// *                                                                       *
// *    OMEGA C++ Windowing Class Library                                  *
// *    =================================                                  *
// *                                                                       *
// *    Copyright 1991,92 Tom Clancy                                       *
// *    Submitted to the public domain, April 1992                         *
// *                                                                       *
// *************************************************************************
//

#include "omscreen.hpp"
#include "omwin.hpp"

class mywin : public oWindow {
public:
  mywin();
  void display_info();
}

mywin::mywin() {
  setwindow(1,1,80,20,WHITE,BLUE,DOUBLEBAR);
  setshadow(ON,shBottomright);
  settitle(" Window ",tCenter,BLACK,LIGHTGRAY);
}

void mywin::display_info() {
  writebetween(2,1,getwid()-1,WHITE,BLUE,"Welcome to OMEGA!");
  writebetween(4,1,getwid()-1,WHITE,BLUE,"The Object Oriented C++ Library for creating fancy text windowed");
  writebetween(5,1,getwid()-1,WHITE,BLUE,"applications using Borland C++ 2.0");
}

main() {
  initmouse();
  OMEGA_SETUP();
  oScreen S;
  S.setvga50();
  S.activate_virtual();
  S.fillscreen(WHITE,CYAN,32);
  mywin W;
  W.openwin();
  S.deactivate_virtual();
  S.showmouse();
  S.cursoroff();
  W.run();
  S.restoreoldvmode();
  S.hidemouse();
  return 0;
}
