/****************************************************************************/
/*																																					*/
/* UW_KEYS.H 																																*/
/*																																					*/
/* This include contains all the #defines for the integer return values			*/
/* from the getkey() and checkey() functions.																*/
/*																													Kevin Huck			*/
/*																													Boyd Gafford		*/
/*																																					*/
/****************************************************************************/

#define KEY_CTRL_A	  	0x0001
#define KEY_CTRL_B	  	0x0002
#define KEY_CTRL_C	  	0x0003
#define KEY_CTRL_D	  	0x0004
#define KEY_CTRL_E	  	0x0005
#define KEY_CTRL_F	  	0x0006
#define KEY_CTRL_G	  	0x0007
#define KEY_CTRL_H	  	0x0008

#define KEY_BK_SPACE   	0x0008

#define KEY_CTRL_I	  	0x0009
#define KEY_TAB			   	0x0009

#define KEY_CTRL_J	  	0x000A
#define KEY_CTRL_K	  	0x000B
#define KEY_CTRL_L	  	0x000C

#define KEY_CTRL_M	  	0x000D
#define KEY_ENTER		   	0x000D

#define KEY_CTRL_N	  	0x000E
#define KEY_CTRL_O	  	0x000F
#define KEY_CTRL_P	  	0x0010
#define KEY_CTRL_Q	  	0x0011
#define KEY_CTRL_R	  	0x0012
#define KEY_CTRL_S	  	0x0013
#define KEY_CTRL_T	  	0x0014
#define KEY_CTRL_U	  	0x0015
#define KEY_CTRL_V	  	0x0016
#define KEY_CTRL_W	  	0x0017
#define KEY_CTRL_X	  	0x0018
#define KEY_CTRL_Y	  	0x0019
#define KEY_CTRL_Z	  	0x001A

#define KEY_ESC			   	0x001B

#define KEY_SHFT_TAB   	0x010F

#define KEY_ALT_A		  	0x011E
#define KEY_ALT_B		  	0x0130
#define KEY_ALT_C		  	0x012E
#define KEY_ALT_D		  	0x0120
#define KEY_ALT_E		  	0x0112
#define KEY_ALT_F		  	0x0121
#define KEY_ALT_G		  	0x0122
#define KEY_ALT_H		  	0x0123
#define KEY_ALT_I		  	0x0117
#define KEY_ALT_J		  	0x0124
#define KEY_ALT_K		  	0x0125
#define KEY_ALT_L		  	0x0126
#define KEY_ALT_M		  	0x0132
#define KEY_ALT_N		  	0x0131
#define KEY_ALT_O		  	0x0118
#define KEY_ALT_P		  	0x0119
#define KEY_ALT_Q		  	0x0110
#define KEY_ALT_R		  	0x0113
#define KEY_ALT_S		  	0x011F
#define KEY_ALT_T		  	0x0114
#define KEY_ALT_U		  	0x0116
#define KEY_ALT_V		  	0x012F
#define KEY_ALT_W		  	0x0111
#define KEY_ALT_X		  	0x012D
#define KEY_ALT_Y		  	0x0115
#define KEY_ALT_Z		  	0x012C

#define KEY_F1			  	0x013B
#define KEY_F2			  	0x013C
#define KEY_F3			  	0x013D
#define KEY_F4			  	0x013E
#define KEY_F5			  	0x013F
#define KEY_F6			  	0x0140
#define KEY_F7			  	0x0141
#define KEY_F8			  	0x0142
#define KEY_F9			  	0x0143
#define KEY_F10			  	0x0144

#define KEY_HOME		   	0x0147
#define KEY_UP			   	0x0148
#define KEY_PGUP		   	0x0149
#define KEY_LEFT       	0x014B
#define KEY_RIGHT      	0x014D
#define KEY_END		     	0x014F
#define KEY_DN		     	0x0150
#define KEY_PGDN	     	0x0151
#define KEY_INSERT	   	0x0152
#define KEY_DELETE	   	0x0153

#define KEY_CTRL_F1	  	0x015E
#define KEY_CTRL_F2	  	0x015F
#define KEY_CTRL_F3	  	0x0160
#define KEY_CTRL_F4	  	0x0161
#define KEY_CTRL_F5	  	0x0162
#define KEY_CTRL_F6	  	0x0163
#define KEY_CTRL_F7	  	0x0164
#define KEY_CTRL_F8	  	0x0165
#define KEY_CTRL_F9	  	0x0166
#define KEY_CTRL_F10  	0x0167

#define KEY_ALT_F1	  	0x0168
#define KEY_ALT_F2	  	0x0169
#define KEY_ALT_F3	  	0x016A
#define KEY_ALT_F4	  	0x016B
#define KEY_ALT_F5	  	0x016C
#define KEY_ALT_F6	  	0x016D
#define KEY_ALT_F7	  	0x016E
#define KEY_ALT_F8	  	0x016F
#define KEY_ALT_F9	  	0x0170
#define KEY_ALT_F10	  	0x0171

#define KEY_SHIFT_F1    0x0154
#define KEY_SHIFT_F2    0x0155
#define KEY_SHIFT_F3    0x0156
#define KEY_SHIFT_F4    0x0157
#define KEY_SHIFT_F5    0x0158
#define KEY_SHIFT_F6    0x0159
#define KEY_SHIFT_F7    0x015a
#define KEY_SHIFT_F8    0x015b
#define KEY_SHIFT_F9    0x015c
#define KEY_SHIFT_F10   0x015d

#define KEY_CTRL_LEFT   0x0173
#define KEY_CTRL_RIGHT  0x0174
#define KEY_CTRL_END	  0x0175
#define KEY_CTRL_PGDN	  0x0176
#define KEY_CTRL_HOME	  0x0177
#define KEY_ALT_1			  0x0178
#define KEY_ALT_2			  0x0179
#define KEY_ALT_3			  0x017A
#define KEY_ALT_4			  0x017B
#define KEY_ALT_5			  0x017C
#define KEY_ALT_6			  0x017D
#define KEY_ALT_7			  0x017E
#define KEY_ALT_8			  0x017F
#define KEY_ALT_9			  0x0180
#define KEY_ALT_0			  0x0181
#define KEY_ALT_MINUS	  0x0182
#define KEY_ALT_EQUALS  0x0183
#define KEY_CTRL_PGUP	  0x0184


#define MOD_SHIFT_RIGHT	0x0001
#define MOD_SHIFT_LEFT	0x0002
#define MOD_CTRL				0x0004
#define MOD_ALT					0x0008
#define MOD_SCROLL_LOCK	0x0010
#define MOD_NUM_LOCK		0x0020
#define MOD_CAPS_LOCK		0x0040
