/***   BSTRING.H  ***/
/* Written By P.A. McKenzie
 * The C Window Library
 * Copyright (C) 1990   All Rights Reserved
*/

#ifndef BIT_STRING_DEF
#define BIT_STRING_DEF
#undef  PROTO_DEF
#include "proto.h"

typedef struct
{
  unsigned char *bit_string;
  unsigned nbits;
} BITSTRING;

#define clear_bits(b,s,e)      set_clear_bits((b),(s),(e),0)
#define set_bits(b,s,e)        set_clear_bits((b),(s),(e),1)

#if __cplusplus
  extern "C" {
#endif
int          create_bit_string P((BITSTRING *, unsigned));
void         free_bit_string P((BITSTRING *));
void         set_clear_bits P((BITSTRING *, unsigned, unsigned, int));
unsigned     get_bits_set P((BITSTRING *));
int          test_bit P((BITSTRING *, unsigned));
unsigned     get_first_bit_set P((BITSTRING *, unsigned));
#if __cplusplus
  }
#endif
#endif
