/*** KEY.H ***/

/* Written By P.A. McKenzie
 * The C Window Library
 * Copyright (C) 1990   All Rights Reserved
*/
#ifndef KEY_DEF
#define KEY_DEF
#if defined (GLOBAL_DEF)
#define EXTERN
#else
#define EXTERN extern
#endif
#include "keycodes.h"

#define FLUSH_KEYBOARD()       flush_keyboard(enhanced_keyboard?17:1)
#define ISKEYREADY()           key_ready(enhanced_keyboard?17:1)
#define GET_SHIFT_STATE()      bioskbd(2)
#define GET_KEY()              getkeyfunc(0)
#define GET_ENHANCED_KEY()     getkeyfunc(1)
#define ENHANCED_KEYBOARD()    (enhanced_keyboard?1:0)

#define OVERSTRIKEMODE      0
#define INSERTMODE          1

#define UPPERCASE                1
#define LOWERCASE                2
#define CHECKSPACES              4
#define ENHANCEDKEY              8
#define CHECKREGEXP             16
#define AUTORETURN              32
#define CHECKREGEXP_IGNORECASE  64

#define DONT_PROCESS        0
#define MOVE_CURSOR_LEFT    1
#define MOVE_CURSOR_RIGHT   2
#define DELETE_AT_CURSOR    3
#define TOGGLE_INSERT       4
#define DESTRUCT_BACKSPACE  5
#define ACCEPT_INPUT        6
#define ACCEPT_DEFAULT      7
#define ERASE_INPUT         8
#define GOTO_FIRST          9
#define GOTO_LAST          10
#define INSERT_CHARACTER   11

EXTERN int default_cursor_type[2];
EXTERN int default_cursor_mode;
EXTERN int enhanced_keyboard;
EXTERN unsigned int last_key_hit;
EXTERN int (*undef_fkey_func)(char *,int,int);
EXTERN int (*undef_akey_func)(char *,int,int);
EXTERN int (*num_chars_entered_func)(char *,int);
EXTERN int (*reg_exp_error_func)(char *, int);

#if __cplusplus
   extern "C" {
#endif

EXTERN int flush_keyboard_flag;
unsigned bioskbd(int);
int GetEnhancedKeyboard (void);
unsigned getkeyfunc(int);
int key_ready(int);
void flush_keyboard(int);

#if __cplusplus
   }
#endif

#endif
