/*** KEYCODES.H ***/

/* Written By P.A. McKenzie
 * The C Window Library
 * Copyright (C) 1990   All Rights Reserved
*/
#if !defined (KEYCODES_DEF)
#define KEYCODES_DEF
#define F1               0x3b00
#define SHIFTF1          0x5400
#define CTRLF1           0x5e00
#define ALTF1            0x6800

#define F2               0x3c00
#define SHIFTF2          0x5500
#define CTRLF2           0x5f00
#define ALTF2            0x6900

#define F3               0x3d00
#define SHIFTF3          0x5600
#define CTRLF3           0x6000
#define ALTF3            0x6a00

#define F4               0x3e00
#define SHIFTF4          0x5700
#define CTRLF4           0x6100
#define ALTF4            0x6b00

#define F5               0x3f00
#define SHIFTF5          0x5800
#define CTRLF5           0x6200
#define ALTF5            0x6c00

#define F6               0x4000
#define SHIFTF6          0x5900
#define CTRLF6           0x6300
#define ALTF6            0x6d00

#define F7               0x4100
#define SHIFTF7          0x5a00
#define CTRLF7           0x6400
#define ALTF7            0x6e00

#define F8               0x4200
#define SHIFTF8          0x5b00
#define CTRLF8           0x6500
#define ALTF8            0x6f00

#define F9               0x4300
#define SHIFTF9          0x5c00
#define CTRLF9           0x6600
#define ALTF9            0x7000

#define F10              0x4400
#define SHIFTF10         0x5d00
#define CTRLF10          0x6700
#define ALTF10           0x7100

#define F11              0x8500
#define SHIFTF11         0x8700
#define CTRLF11          0x8900
#define ALTF11           0x8b00

#define F12              0x8600
#define SHIFTF12         0x8800
#define CTRLF12          0x8a00
#define ALTF12           0x8c00

#define LARROW           0x4b00
#define SHIFTLARROW    '4'
#define CTRLLARROW       0x7300

#define RARROW           0x4d00
#define SHIFTRARROW    '6'
#define CTRLRARROW       0x7400

#define UARROW           0x4800
#define SHIFTUARROW    '8'
#define CTRLUARROW       0x8d00

#define DARROW           0x5000
#define SHIFTDARROW    '2'
#define CTRLDARROW       0x9100

#define GRAY_LARROW      0x4be0
#define GRAY_CTRLLARROW  0x73e0

#define GRAY_RARROW      0x4de0
#define GRAY_CTRLRARROW  0x74e0

#define GRAY_UARROW      0x48e0
#define GRAY_CTRLUARROW  0x8de0

#define GRAY_DARROW      0x50e0
#define GRAY_CTRLDARROW  0x91e0

#define HOME             0x4700
#define GRAY_HOME        0x47e0
#define SHIFTHOME     '7'

#define CTRLHOME         0x7700
#define GRAY_CTRLHOME    0x77e0

#define END              0x4f00
#define SHIFTEND      '1'
#define CTRLEND          0x7500

#define GRAY_END         0x4fe0
#define GRAY_CTRLEND     0x75e0

#define PGUP             0x4900
#define SHIFTPGUP     '9'
#define CTRLPGUP         0x8400

#define GRAY_PGUP        0x49e0
#define GRAY_CTRLPGUP    0x84e0

#define PGDN             0x5100
#define SHIFTPGDN     '3'
#define CTRLPGDN         0x7600

#define GRAY_PGDN        0x51e0
#define GRAY_CTRLPGDN    0x76e0

#define INS              0x5200
#define SHIFTINS      '0'

#define GRAY_INS         0x52e0

#define DEL              0x5300
#define SHIFTDEL      '.'

#define GRAY_DEL         0x53e0

#define ESC           0x1B
#define SHIFTESC      0x1B
#define CTRLESC       0x1B
#define BACKSP        8
#define SHIFTBACKSP   8
#define CTRLBACKSP    127
#define TAB           9
#define SHIFTTAB      0x0F00
#define RETURN        13
#define CTRLRETURN    10

#define GRAY_ENTER     0xe00d
#define GRAY_MINUS     0x4a2d
#define GRAY_PLUS      0x4e2b
#define GRAY_DIVIDE    0xe02f
#define GRAY_MULTIPLY  0x372a

#define CTRLA         1
#define CTRLB         2
#define CTRLC         3
#define CTRLD         4
#define CTRLE         5
#define CTRLF         6
#define CTRLG         7
#define CTRLH         8
#define CTRLI         9
#define CTRLJ         10
#define CTRLK         11
#define CTRLL         12
#define CTRLM         13
#define CTRLN         14
#define CTRLO         15
#define CTRLP         16
#define CTRLQ         17
#define CTRLR         18
#define CTRLS         19
#define CTRLT         20
#define CTRLU         21
#define CTRLV         22
#define CTRLW         23
#define CTRLX         24
#define CTRLY         25
#define CTRLZ         26

#define ALTA          0x1e00
#define ALTB          0x3000
#define ALTC          0x2e00
#define ALTD          0x2000
#define ALTE          0x1200
#define ALTF          0x2100
#define ALTG          0x2200
#define ALTH          0x2300
#define ALTI          0x1700
#define ALTJ          0x2400
#define ALTK          0x2500
#define ALTL          0x2600
#define ALTM          0x3200
#define ALTN          0x3100
#define ALTO          0x1800
#define ALTP          0x1900
#define ALTQ          0x1000
#define ALTR          0x1300
#define ALTS          0x1f00
#define ALTT          0x1400
#define ALTU          0x1600
#define ALTV          0x2f00
#define ALTW          0x1100
#define ALTX          0x2d00
#define ALTY          0x1500
#define ALTZ          0x2c00
#define ALT0          0x8100
#define ALT1          0x7800
#define ALT2          0x7900
#define ALT3          0x7a00
#define ALT4          0x7b00
#define ALT5          0x7c00
#define ALT6          0x7d00
#define ALT7          0x7e00
#define ALT8          0x7f00
#define ALT9          0x8000
#define ALTHYPHEN     0x8200
#define ALTEQUAL      0x8300

#define RSHIFT        1
#define LSHIFT        2
#define CTRL          4
#define ALT           8
#define SCRLOCK       16
#define NUMLOCK       32
#define CAPSLOCK      64
#define INSERT        128
#define LCTRL         256
#define LALT          512
#define RCTRL         1024
#define RALT          2048
#define SCRLOCK2      4096
#define NUMLOCK2      8192
#define CAPSLOCK2     16384
#define SYSREQ        32768
#endif
